clear
close all
clc

%Have to put in correct file path to enter 
%"Result Record_Primal\UpDownDisturbance" from the Primal code folder
FolderName = 'C:\Users\Vegard\Documents\Skole\NTNU\2023\Master\Code\Dual - Override - Vegard\Resultater';

%Result Primal Decomposition well 3 as compensator
noisePrimC3 = load(fullfile(FolderName, 'Override-AntiWindup-Well1-Tc125-PI-New'));%load(fullfile(FolderName, 'Primal_DisturbanceUpDown_Noise'));
noNoisePrimC3 = load(fullfile(FolderName, 'Primal_DisturbanceUpDown_NoNoise'));

%Result Primal Decomposition well 2 as compensator
noisePrimC2 = load(fullfile(FolderName, 'Override-AntiWindup-Well2-Tc125-PI-New'));%load(fullfile(FolderName, 'Primal_DisturbanceUpDown_Noise_Comp2'));
noNoisePrimC2 = load(fullfile(FolderName, 'Primal_DisturbanceUpDown_NoNoise_Comp2'));

%Result Primal Decomposition well 1 as compensator
noisePrimC1 = load(fullfile(FolderName, 'Primal_DisturbanceUpDown_Noise_Comp1'));
noNoisePrimC1 = load(fullfile(FolderName, 'Primal_DisturbanceUpDown_NoNoise_Comp1'));

%Result Dual Decomposition
noiseDual = load(fullfile(FolderName, 'Override-AntiWindup-Well2-Tc125-PI-New'));%load(fullfile(FolderName, 'ROPA_Noise'));

noNoiseDual = load(fullfile(FolderName, 'ROPA_NoNoise'));

%Result Base Case
noiseBase = load(fullfile(FolderName, 'BaseCase_Noise'));
noNoiseBase = load(fullfile(FolderName, 'BaseCase_NoNoise'));

%Result Dual With Override
noiseDualOver1 = load(fullfile(FolderName, 'Override-AntiWindup-Well1-Tc125-I-New'));%load(fullfile(FolderName, 'Override-AntiWindup-Well1-Tc50'));
noiseDualOver2 = load(fullfile(FolderName, 'Override-AntiWindup-Well2-Tc125-I-New'));%load(fullfile(FolderName, 'Override-AntiWindup-Well2-Tc50'));
noiseDualOver3 = load(fullfile(FolderName, 'Override-AntiWindup-Well3-Tc125-I-New'));%load(fullfile(FolderName, 'Override-AntiWindup-Well3-Tc50'));
noiseOverPI = load(fullfile(FolderName, 'Override-PI-control-New'));

len = 2717;
tgrid = (0:1:len-1)/60;

%Gas Lift w/noise
qg_Primal = noisePrimC3.uPlantArray(1:3,1:len);
qg_Dual = noiseDual.uPlantArray(1:3,1:len);
qg_DualOver1 = noiseDualOver1.uPlantArray(1:3,1:len);
qg_DualOver2 = noiseDualOver2.uPlantArray(1:3,1:len);
qg_DualOver3 = noiseDualOver3.uPlantArray(1:3,1:len);
qg_OverPI = noiseOverPI.uPlantArray(1:3,1:len);

%Gas Lift setpoints w/noise
qg_sp_Primal = noisePrimC3.uImpArray(1:3,1:len);
qg_sp_Dual = noiseDual.uImpArray(1:3,1:len);
qg_sp_DualOver1 = noiseDualOver1.uImpArray(1:3,1:len);
qg_sp_DualOver2 = noiseDualOver2.uImpArray(1:3,1:len);
qg_sp_DualOver3 = noiseDualOver3.uImpArray(1:3,1:len);
qg_sp_OverPI = noiseOverPI.uImpArray(1:3,1:len);
u0 = [2.5008;2.4990;2.5003];
for i = 1:61
    for j = 1:3
        qg_sp_Primal(j,i) = u0(j);
        qg_sp_Dual(j,i) = u0(j);
        qg_sp_DualOver1(j,i) = u0(j);
        qg_sp_DualOver2(j,i) = u0(j);
        qg_sp_DualOver3(j,i) = u0(j);
        qg_sp_OverPI(j,i) = u0(j);
    end
end

%% Accumilated cost function

costAccNoise = [0;0;0;0;0];
costNoise = [0;0;0;0;0];
diffBase = [0;0;0;0];
diffAccBase = [0;0;0;0];
diffComp = [0;0];
for i = 1:2275
    costAccNoise = [costAccNoise, [costAccNoise(1,end)+noisePrimC1.ofPlantArray(i); costAccNoise(2,end)+noisePrimC2.ofPlantArray(i); costAccNoise(3,end)+noisePrimC3.ofPlantArray(i); costAccNoise(4,end)+noiseDual.ofPlantArray(i); costAccNoise(5,end)+noiseBase.ofPlantArray(i)]];
    costNoise = [costNoise, [noisePrimC1.ofPlantArray(i); noisePrimC2.ofPlantArray(i); noisePrimC3.ofPlantArray(i); noiseDual.ofPlantArray(i); noiseBase.ofPlantArray(i)]];
    
    diff1 = (costNoise(1,end)-costNoise(5,end))/costNoise(5,end);
    diff2 = (costNoise(2,end)-costNoise(5,end))/costNoise(5,end);
    diff3 = (costNoise(3,end)-costNoise(5,end))/costNoise(5,end);
    diff4 = (costNoise(4,end)-costNoise(5,end))/costNoise(5,end);
    diffBase = [diffBase, 100*[diff1; diff2; diff3; diff4]];
    accdiff1 = (costAccNoise(1,end)/costAccNoise(5,end))-1;
    accdiff2 = (costAccNoise(2,end)/costAccNoise(5,end))-1;
    accdiff3 = (costAccNoise(3,end)/costAccNoise(5,end))-1;
    accdiff4 = (costAccNoise(4,end)/costAccNoise(5,end))-1;
    diffAccBase = [diffAccBase, 100*[accdiff1;accdiff2;accdiff3;accdiff4]];
    Comp31diff = 100*((costAccNoise(3,end)/costAccNoise(1,end))-1);
    Comp32diff = 100*((costAccNoise(3,end)/costAccNoise(2,end))-1);
    diffComp = [diffComp, [Comp31diff; Comp32diff;]];
end
f6 = figure(6);
f6.Position = [700 400 750 250];
plot(tgrid, diffComp(1,:), 'r','Linewidth',1.5);
hold on;
plot(tgrid, diffComp(2,:), 'b','Linewidth',1.5);
% plot(tgrid, costAccNoise(3,:), 'r');
grid on;
legend({'Profit well 3 vs well 1', 'Profit well 3 vs well 2'})
ylabel('$P_{diff} [\%]$','Interpreter','latex','FontSize',15)
xlabel('time [min]','FontSize',10)
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])

test = costAccNoise(3,end)-costAccNoise(4,end)

f1 = figure(1);
f1.Position = [700 400 750 250];
%plot(tgrid, diffBase(1,:), 'k');
plot(tgrid, diffBase(3,:), 'r','Linewidth',1.5);
hold on;
%plot(tgrid, diffBase(2,:), 'g');
plot(tgrid, diffBase(4,:), 'b','Linewidth',1.5);
grid on;

legend({'Primal','Dual'},'Orientation','horizontal')
ylim([-1.5 3])
ylabel('$P_{diff} [\%]$','Interpreter','latex','FontSize',15)

xlabel('time [min]','FontSize',10)
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])

f2 = figure(2);
f2.Position = [700 400 750 250];
% plot(tgrid, diffAccBase(1,:), 'b');
% hold on;
% plot(tgrid, diffAccBase(2,:), 'g');
% plot(tgrid, diffAccBase(3,:), 'k');
% plot(tgrid, diffAccBase(4,:), 'r');
plot(tgrid, costNoise(4,:),'b')
plot(tgrid, costNoise(5,:),'r')
grid on;

%ylim([-0.5 2])
xticks(0:1:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])

%% sum of gas lift
GLmax = 7.5*ones(1,len);

f3 = figure(3);
f3.Position = [700 400 750 250];
%plot(tgrid, qg_Primal(1,:)+qg_Primal(2,:)+qg_Primal(3,:), 'r','Linewidth',1.5)
%hold on;
%plot(tgrid, qg_Dual(1,:)+qg_Dual(2,:)+qg_Dual(3,:), 'b','Linewidth',1.5)
plot(tgrid, qg_DualOver1(1,:)+qg_DualOver1(2,:)+qg_DualOver1(3,:), 'g','Linewidth',1.5)
hold on;
plot(tgrid, qg_DualOver2(1,:)+qg_DualOver2(2,:)+qg_DualOver2(3,:), 'b','Linewidth',1.5)
plot(tgrid, qg_DualOver3(1,:)+qg_DualOver3(2,:)+qg_DualOver3(3,:), 'r','Linewidth',1.5)
%plot(tgrid, qg_OverPI(1,:)+qg_OverPI(2,:)+qg_OverPI(3,:), 'k','Linewidth',1.5)
plot(tgrid,GLmax,'--k')
grid on;

xlabel('time [min]','FontSize',15)
ylabel('$\sum_{i=1}^3 Q_{gl,i}$','Interpreter','latex','FontSize',20)
%legend({'Primal','Dual','Override','Q_{max}'},'Orientation','horizontal')
legend({'Well 1','Well 2','Well 3','Q^{max}'},'Orientation','horizontal','location','northoutside')
yticks(5.5:0.5:9.5)
ylim([6 9.5])
xticks(0:5:(1/60)*(len - 1))
xlim([0 (1/60)*(len - 1)])

% axes('Position',[.3 .7 .2 .22])
% box on
% plot(tgrid(300:1:400), qg_Primal(1,300:1:400)+qg_Primal(2,300:1:400)+qg_Primal(3,300:1:400), 'r','Linewidth',1.5)
% hold on;
% plot(tgrid(300:1:400),GLmax(300:1:400),'--g')
% grid on
% % yticks(7.35:0.1:7.65)
% % yticklabels({'7.35','7.45','7.55','7.65'})
% xticks(5:0.5:6.5)

%% Implemented Gas lift every well

f4 = figure(4);
f4.Position = [400 50 750 750];
for well = 1:3
    subplot(3,1,well)
%     plot(tgrid, qg_Primal(well,:),'r','Linewidth',1.5)
%     hold on;
%     plot(tgrid, qg_Dual(well,:),'b','Linewidth',1.5)
    plot(tgrid, qg_DualOver1(well,:),'g','Linewidth',1.5)
    hold on;
    plot(tgrid, qg_DualOver2(well,:),'b','Linewidth',1.5)
    plot(tgrid, qg_DualOver3(well,:),'r','Linewidth',1.5)
    %plot(tgrid, qg_OverPI(well,:),'k','Linewidth',1.5)
    grid on;
    
    y_lab = ['{gl, ',num2str(well),'}'];
    ylabel(['$Q_',y_lab,'$'],'Interpreter','latex','FontSize',15)
    xlabel('time [min]','FontSize',10)
    
    xticks(0:5:(1/60)*(len - 1))
    xlim([0 (1/60)*(len - 1)])
    
    legend({'Well 1','Well 2','Well 3'},'Orientation','horizontal','location','northoutside')
end
% legend({'Primal','Dual','Override'},'Orientation','horizontal')


%% SetPoint Gas lift every well

f5 = figure(5);
f5.Position = [400 50 750 750];
for well = 1:3
    subplot(3,1,well)
    plot(tgrid(2:2:end-1), qg_sp_Primal(well,2:2:end),'r','Linewidth',1.5)
    hold on;
    plot(tgrid(2:2:end-1), qg_sp_Dual(well,2:2:end),'b','Linewidth',1.5)
%    plot(tgrid(2:2:end-1), qg_sp_DualOver1(well,2:2:end),'g','Linewidth',1.5)
%    hold on;
    plot(tgrid(2:2:end-1), qg_sp_DualOver2(well,2:2:end),'g','Linewidth',1.5)
%     plot(tgrid(2:2:end-1), qg_sp_OverPI(well,2:2:end),'k','Linewidth',1.5)
%    plot(tgrid(2:2:end-1), qg_sp_DualOver3(well,2:2:end),'r','Linewidth',1.5)
    grid on;
    
    y_lab = ['{gl, ',num2str(well),'}'];
    ylabel(['$Q_',y_lab,'^{sp}$'],'Interpreter','latex','FontSize',20)
    xlabel('time [min]','FontSize',15)
    
    xticks(0:5:(1/60)*(2276 - 1))
    xlim([0 (1/60)*(2276 - 1)])
end
%legend({'Primal','Dual','Override'},'Orientation','horizontal','FontSize',15)
legend({'Compensator Well 1','Compensator Well 2','Compensator Well 3'},'Orientation','horizontal','location','northoutside')

%% Disturbances

f7 = figure(7);
f7.Position = [400 100 500 250];
plot(tgrid, noisePrimC3.uPlantArray(4,:),'b','Linewidth',2)
hold on;
plot(tgrid, noisePrimC3.uPlantArray(5,:),'r','Linewidth',2)
plot(tgrid, noisePrimC3.uPlantArray(6,:),'y','Linewidth',2)
grid on;

ylabel('$d$','Interpreter','latex','FontSize',20)
xlabel('time [min]','FontSize',15)
ylim([0 1])
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])

legend({'d_1','d_2','d_3'},'FontSize',15)

%% Lambdas

f8 = figure(8);
f8.Position = [400 100 375 200];
plot(tgrid(63:2:end), noisePrimC3.Lu(1,62:2:end),'b','Linewidth',1.5)
hold on; 
plot(tgrid(63:2:end), noisePrimC3.Lu(2,62:2:end),'k','Linewidth',1.5)
plot(tgrid(63:2:end), noisePrimC3.Lu(3,62:2:end),'g','Linewidth',1.5)
grid on;
    
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])
    
%title('Lambdas')
ylabel('\lambda_{i}','FontSize',15)
xlabel('time [min]','FontSize',10)
legend({'\lambda_1','\lambda_2','\lambda_3'},'FontSize',10)

f9 = figure(9);
f9.Position = [400 100 375 200];
plot(tgrid(63:2:end), noiseDual.ofArray(1,62:2:end),'b','Linewidth',1.5)
hold on;
plot(tgrid(63:2:end), noiseDualOver1.ofArray(1,62:2:end),'k','Linewidth',1.5)

grid on;
    
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])
ylim([5 12])

ylabel('\lambda','FontSize',15)
xlabel('time [min]','FontSize',10)

f11 = figure(11);
f11.Position = [400 100 750 250];
plot(tgrid(63:2:end), noNoisePrimC3.Lu(1,62:2:end),'b','Linewidth',1.5)
hold on; 
plot(tgrid(63:2:end), noNoisePrimC3.Lu(2,62:2:end),'k','Linewidth',1.5)
plot(tgrid(63:2:end), noNoisePrimC3.Lu(3,62:2:end),'g','Linewidth',1.5)
grid on;
    
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])
    
%title('Lambdas')
ylabel('\lambda_{i}','FontSize',15)
xlabel('time [min]')
legend({'\lambda_1','\lambda_2','\lambda_3'})

%% Liquid flowrate

f10 = figure(10);
f10.Position = [400 100 375 250];

plot(tgrid, noisePrimC3.measPlantArray(1,:)+noisePrimC3.measPlantArray(2,:)+noisePrimC3.measPlantArray(3,:), 'r')
hold on;
plot(tgrid, noiseDual.measPlantArray(1,:)+noiseDual.measPlantArray(2,:)+noiseDual.measPlantArray(3,:), 'b')
%plot(tgrid(63:2:end), noisePrimC3.yEstArray(1,62:2:end)+noisePrimC3.yEstArray(2,62:2:end)+noisePrimC3.yEstArray(3,62:2:end), 'g')
%plot(tgrid(63:2:end), noiseBase.yEstArray(1,62:2:end)+noiseBase.yEstArray(2,62:2:end)+noiseBase.yEstArray(3,62:2:end), 'k')

grid on;

legend({'Primal','Dual'},'Orientation','horizontal','FontSize',10)
ylabel('$\sum_{i=1}^3 Q_{l,i}$','Interpreter','latex','FontSize',15)
xlabel('time [min]')
    
xticks(0:5:(1/60)*(2276 - 1))
xlim([0 (1/60)*(2276 - 1)])

